﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Serialization;

namespace Zekken.Avoidance
{
    [Serializable]
    public class XSpellShape
    {
        [XmlElement("Id")]
        public uint Id { get; set; }

        [XmlElement("Flags")]
        public List<SpellShape> Flags { get; set; }

        public void MergeWith(XSpellShape other)
        {
            foreach (var flag in other.Flags.Where(f => !Flags.Contains(f))) { Flags.Add(flag); }
        }

        public SpellShape GetShape()
        {
            return Flags.Aggregate(SpellShape.None, (current, flag) => flag | current);
        }
    }
}